/*
 *************************************************************************
 * The contents of this file are subject to the Openbravo  Public  License
 * Version  1.1  (the  "License"),  being   the  Mozilla   Public  License
 * Version 1.1  with a permitted attribution clause; you may not  use this
 * file except in compliance with the License. You  may  obtain  a copy of
 * the License at http://www.openbravo.com/legal/license.html 
 * Software distributed under the License  is  distributed  on  an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific  language  governing  rights  and  limitations
 * under the License.
 * The Original Code is Openbravo ERP.
 * The Initial Developer of the Original Code is Openbravo SLU
 * All portions are Copyright (C) 2010-2011 Openbravo SLU
 * All Rights Reserved.
 * Contributor(s):  ______________________________________.
 ************************************************************************
*/

isc.OBWidgetMenu.addProperties({
  baseStyle: 'OBWidgetMenuCell', // menu in standard SC
  styleName: 'OBWidgetMenu', // normal in standard sc
  bodyStyleName: 'OBWidgetMenuBody', // normal in standard sc
  tableStyle: 'OBWidgetMenuTable', // menuTable in standard SC
  iconBodyStyleName: 'OBWidgetMenuTable'
});

isc.OBWidgetMenuItem.addProperties({
  showIcon: false,
  showOver: true,
  showRollOver: true,
  showDown: false,
  showFocused: false,
  showFocusedAsOver: false,
  showTitle: false,
  imageType: isc.Img.CENTER,
  width: 24,
  height: 24,
  src: OB.Styles.skinsPath + 'Default/org.openbravo.client.myob/images/widget/edit.png',
  baseStyle: 'OBWidgetMenuButton',
  overflow: 'visible'
});


isc.OBWidget.addProperties({
  headerStyle: 'OBWidgetHeader',
  showEdges:true,
  edgeImage: OB.Styles.skinsPath + 'Default/org.openbravo.client.myob/images/widget/window.png',
  customEdges:null,
  edgeSize:2,
  edgeTop:27,
  edgeBottom:2,
  edgeOffsetTop:2,
  edgeOffsetRight:2,
  edgeOffsetBottom:2,
  showHeaderBackground:false, // part of edges
  showHeaderIcon:true,

      // clear backgroundColor and style since corners are rounded
  backgroundColor:null,
  border: null,
  edgeCenterBackgroundColor:"#FFFFFF",
  bodyColor:"transparent",
  bodyStyle:"windowBody",

  layoutMargin:0,
  membersMargin:0,

  showFooter:false,

  showShadow:false,
  shadowDepth:5
});

isc.OBWidget.changeDefaults('headerDefaults', {
  layoutMargin: 0,
  height: 25
});

isc.OBWidget.changeDefaults('headerLabelDefaults', {
  styleName: 'OBWidgetHeaderText',
  align: isc.Canvas.CENTER
});

isc.OBWidget.changeDefaults('restoreButtonDefaults', {
  baseStyle: 'OBWidgetIconRestore',
  src: OB.Styles.skinsPath + 'Default/org.openbravo.client.myob/images/widget/restore.png',
  width: 24,
  height: 20
});

isc.OBWidget.changeDefaults('closeButtonDefaults', {
  baseStyle: 'OBWidgetIconClose',
  src: OB.Styles.skinsPath + 'Default/org.openbravo.client.myob/images/widget/close.png',
  width: 24,
  height: 20
});

isc.OBWidget.changeDefaults('maximizeButtonDefaults', {
  baseStyle: 'OBWidgetIconMaximize',
  src: OB.Styles.skinsPath + 'Default/org.openbravo.client.myob/images/widget/maximize.png',
  width: 24,
  height: 20
});

isc.OBWidget.changeDefaults('minimizeButtonDefaults', {
  baseStyle: 'OBWidgetIconMinimize',
  src: OB.Styles.skinsPath + 'Default/org.openbravo.client.myob/images/widget/minimize.png',
  width: 24,
  height: 20
});

// MyOpenbravo dialogs (left menu)

isc.OBMyOBDialog.addProperties({
  styleName : 'OBMyOBDialog',
  headerStyle : 'OBMyOBDialogHeader',
  bodyStyle : "OBMyOBDialogBody",
  showEdges : true,
  edgeImage : OB.Styles.skinsPath + 'Default/org.openbravo.client.myob/images/dialog/window.png',
  customEdges : null,
  edgeSize : 6,
  edgeTop : 23,
  edgeBottom : 6,
  edgeOffsetTop : 2,
  edgeOffsetRight : 5,
  edgeOffsetBottom : 5,
  showHeaderBackground : false, // part of edges
  showHeaderIcon : true,

  border : null,

  layoutMargin : 0,
  membersMargin : 0,

  showFooter : false,

  showShadow : false,
  shadowDepth : 5
});

isc.OBMyOBDialog.changeDefaults('headerDefaults', {
  layoutMargin : 0,
  height : 24
});

isc.OBMyOBDialog.changeDefaults('headerLabelDefaults', {
  styleName : 'OBMyOBDialogHeaderText',
  align : isc.Canvas.CENTER
});

isc.OBMyOBDialog.changeDefaults("closeButtonDefaults", {
  src: OB.Styles.skinsPath + 'Default/org.openbravo.client.myob/images/dialog/headerIcons/close.png',
  showRollOver:true,
  showDown:false,
  width:15,
  height:15
});