
package org.openbravo.erpCommon.ad_callouts;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.openbravo.base.secureApp.VariablesSecureApp;
import org.openbravo.data.Sqlc;
import org.openbravo.erpCommon.utility.*;
import org.openbravo.xmlEngine.XmlDocument;

public class ComboReloadsCD573DF1E351485EA2B2DE487DCACA6F extends CalloutHelper {
  private static final long serialVersionUID = 1L;

  void printPage(HttpServletResponse response, VariablesSecureApp vars, String strTabId, String windowId) throws IOException, ServletException {
    log4j.debug("Output: dataSheet");
    XmlDocument xmlDocument = xmlEngine.readXmlTemplate("org/openbravo/erpCommon/ad_callouts/CallOut").createXmlDocument();
    
    String parentOrg=vars.getStringParameter("inpParentOrganization");
    StringBuffer resultado = new StringBuffer();
    boolean isFirst=true;
    ComboTableData comboTableData = null;
    resultado.append("var calloutName='ComboReloadsCD573DF1E351485EA2B2DE487DCACA6F';\n\n");
    resultado.append("var respuesta = new Array(\n");

    // check if call came from searchPopup, if yes remember and adjust command name from popup
    // column name pattern to normal pattern and set search popup frame name to be used
    String resultField;
    String command = vars.getStringParameter("Command", "DEFAULT");
    boolean calledFromSearch = command.startsWith("inpParam");
    if (calledFromSearch) {
      command = command.substring(8);
      command = Sqlc.TransformaNombreColumna(command);
      command = "inp" + command;
      xmlDocument.setParameter("frameName", "mainframe");
      xmlDocument.setParameter("frameName1", "mainframe");
    }

    
    try {

    
      if (CalloutHelper.commandInCommandList(command, "inpadOrgId")) {
        if (!isFirst) resultado.append(", \n");
        comboTableData = new ComboTableData(vars, this, "17", "Timing_Option", "ABD8815EDEDB412C820FB94532952721", "", Utility.getReferenceableOrg(vars, vars.getStringParameter("inpadOrgId")), Utility.getContext(this, vars, "#User_Client", windowId), 0);
        if (calledFromSearch) {
          comboTableData.fillParametersFromSearch("", windowId);
          resultField = "inpParamTiming_Option";
        } else {
          comboTableData.fillParameters(null, windowId, "");
          resultField = "inptimingOption";
        }
        resultado.append("new Array(\"" + resultField + "\", ");
        resultado.append(generateArray(comboTableData.select(false), vars.getStringParameter(resultField)));
        comboTableData = null;
        resultado.append(")");
        isFirst=false;
      }
    
      if (CalloutHelper.commandInCommandList(command, "inp#userClient", "inpadOrgId")) {
        if (!isFirst) resultado.append(", \n");
        comboTableData = new ComboTableData(vars, this, "19", "AD_Client_ID", "", "103", Utility.getReferenceableOrg(vars, vars.getStringParameter("inpadOrgId")), Utility.getContext(this, vars, "#User_Client", windowId, 7), 0);
        if (calledFromSearch) {
          comboTableData.fillParametersFromSearch("", windowId);
          resultField = "inpParamAD_Client_ID";
        } else {
          comboTableData.fillParameters(null, windowId, "");
          resultField = "inpadClientId";
        }
        resultado.append("new Array(\"" + resultField + "\", ");
        resultado.append(generateArray(comboTableData.select(false), vars.getStringParameter(resultField)));
        comboTableData = null;
        resultado.append(")");
        isFirst=false;
      }
    
      if (CalloutHelper.commandInCommandList(command, "inpadClientId", "inpadClientId", "inp#userClient", "inp#userOrg", "inpadOrgId")) {
        if (!isFirst) resultado.append(", \n");
        comboTableData = new ComboTableData(vars, this, "19", "AD_Org_ID", "", "104", Utility.getContext(this, vars, "#User_Org", windowId, 7), Utility.getContext(this, vars, "#User_Client", windowId), 0);
        if (calledFromSearch) {
          comboTableData.fillParametersFromSearch("", windowId);
          resultField = "inpParamAD_Org_ID";
        } else {
          comboTableData.fillParameters(null, windowId, "");
          resultField = "inpadOrgId";
        }
        resultado.append("new Array(\"" + resultField + "\", ");
        resultado.append(generateArray(comboTableData.select(false), vars.getStringParameter(resultField)));
        comboTableData = null;
        resultado.append(")");
        isFirst=false;
      }
    
      if (CalloutHelper.commandInCommandList(command, "inpadOrgId")) {
        if (!isFirst) resultado.append(", \n");
        comboTableData = new ComboTableData(vars, this, "19", "AD_Process_ID", "", "800004", Utility.getReferenceableOrg(vars, vars.getStringParameter("inpadOrgId")), Utility.getContext(this, vars, "#User_Client", windowId), 0);
        if (calledFromSearch) {
          comboTableData.fillParametersFromSearch("", windowId);
          resultField = "inpParamAD_Process_ID";
        } else {
          comboTableData.fillParameters(null, windowId, "");
          resultField = "inpadProcessId";
        }
        resultado.append("new Array(\"" + resultField + "\", ");
        resultado.append(generateArray(comboTableData.select(false), vars.getStringParameter(resultField)));
        comboTableData = null;
        resultado.append(")");
        isFirst=false;
      }
    
      if (CalloutHelper.commandInCommandList(command, "inpadOrgId")) {
        if (!isFirst) resultado.append(", \n");
        comboTableData = new ComboTableData(vars, this, "17", "Frequency", "665CE68BB382425BB43057256767B5DE", "", Utility.getReferenceableOrg(vars, vars.getStringParameter("inpadOrgId")), Utility.getContext(this, vars, "#User_Client", windowId), 0);
        if (calledFromSearch) {
          comboTableData.fillParametersFromSearch("", windowId);
          resultField = "inpParamFrequency";
        } else {
          comboTableData.fillParameters(null, windowId, "");
          resultField = "inpfrequency";
        }
        resultado.append("new Array(\"" + resultField + "\", ");
        resultado.append(generateArray(comboTableData.select(false), vars.getStringParameter(resultField)));
        comboTableData = null;
        resultado.append(")");
        isFirst=false;
      }
    
      if (CalloutHelper.commandInCommandList(command, "inpadOrgId")) {
        if (!isFirst) resultado.append(", \n");
        comboTableData = new ComboTableData(vars, this, "17", "Monthly_Day_Of_Week", "167", "", Utility.getReferenceableOrg(vars, vars.getStringParameter("inpadOrgId")), Utility.getContext(this, vars, "#User_Client", windowId), 0);
        if (calledFromSearch) {
          comboTableData.fillParametersFromSearch("", windowId);
          resultField = "inpParamMonthly_Day_Of_Week";
        } else {
          comboTableData.fillParameters(null, windowId, "");
          resultField = "inpmonthlyDayOfWeek";
        }
        resultado.append("new Array(\"" + resultField + "\", ");
        resultado.append(generateArray(comboTableData.select(false), vars.getStringParameter(resultField)));
        comboTableData = null;
        resultado.append(")");
        isFirst=false;
      }
    
      if (CalloutHelper.commandInCommandList(command, "inpadOrgId")) {
        if (!isFirst) resultado.append(", \n");
        comboTableData = new ComboTableData(vars, this, "17", "Monthly_Option", "6C11958E975D4DF8A38E7F4A119A3077", "", Utility.getReferenceableOrg(vars, vars.getStringParameter("inpadOrgId")), Utility.getContext(this, vars, "#User_Client", windowId), 0);
        if (calledFromSearch) {
          comboTableData.fillParametersFromSearch("", windowId);
          resultField = "inpParamMonthly_Option";
        } else {
          comboTableData.fillParameters(null, windowId, "");
          resultField = "inpmonthlyOption";
        }
        resultado.append("new Array(\"" + resultField + "\", ");
        resultado.append(generateArray(comboTableData.select(false), vars.getStringParameter(resultField)));
        comboTableData = null;
        resultado.append(")");
        isFirst=false;
      }
    
      if (CalloutHelper.commandInCommandList(command, "inpadOrgId")) {
        if (!isFirst) resultado.append(", \n");
        comboTableData = new ComboTableData(vars, this, "17", "Status", "7DB6D4792CDC4ED297C70A4F4282A52E", "", Utility.getReferenceableOrg(vars, vars.getStringParameter("inpadOrgId")), Utility.getContext(this, vars, "#User_Client", windowId), 0);
        if (calledFromSearch) {
          comboTableData.fillParametersFromSearch("", windowId);
          resultField = "inpParamStatus";
        } else {
          comboTableData.fillParameters(null, windowId, "");
          resultField = "inpstatus";
        }
        resultado.append("new Array(\"" + resultField + "\", ");
        resultado.append(generateArray(comboTableData.select(false), vars.getStringParameter(resultField)));
        comboTableData = null;
        resultado.append(")");
        isFirst=false;
      }
    
      if (CalloutHelper.commandInCommandList(command, "inpadOrgId")) {
        if (!isFirst) resultado.append(", \n");
        comboTableData = new ComboTableData(vars, this, "17", "Daily_Option", "21A4E92C455C432FACDC0C45372454F5", "", Utility.getReferenceableOrg(vars, vars.getStringParameter("inpadOrgId")), Utility.getContext(this, vars, "#User_Client", windowId), 0);
        if (calledFromSearch) {
          comboTableData.fillParametersFromSearch("", windowId);
          resultField = "inpParamDaily_Option";
        } else {
          comboTableData.fillParameters(null, windowId, "");
          resultField = "inpdailyOption";
        }
        resultado.append("new Array(\"" + resultField + "\", ");
        resultado.append(generateArray(comboTableData.select(false), vars.getStringParameter(resultField)));
        comboTableData = null;
        resultado.append(")");
        isFirst=false;
      }
    

    } catch (ServletException ex) {
      OBError myError = Utility.translateError(this, vars, vars.getLanguage(), ex.toString());
      bdErrorHidden(response, myError.getType(), myError.getTitle(), myError.getMessage());
      return;
    } catch (Exception ex1) {
      OBError myError = Utility.translateError(this, vars, vars.getLanguage(), ex1.toString());
      bdErrorHidden(response, myError.getType(), myError.getTitle(), myError.getMessage());
      return;
    }
    

    resultado.append("\n);");

    xmlDocument.setParameter("array", resultado.toString());
    response.setContentType("text/html; charset=UTF-8");
    PrintWriter out = response.getWriter();
    out.println(xmlDocument.print());
    out.close();
  }

}
