
package org.openbravo.erpWindows.FinancialAccount;




import org.codehaus.jettison.json.JSONObject;
import org.openbravo.erpCommon.utility.*;
import org.openbravo.data.FieldProvider;
import org.openbravo.utils.FormatUtilities;
import org.openbravo.utils.Replace;
import org.openbravo.base.secureApp.HttpSecureAppServlet;
import org.openbravo.base.secureApp.VariablesSecureApp;
import org.openbravo.base.exception.OBException;
import org.openbravo.scheduling.ProcessBundle;
import org.openbravo.scheduling.ProcessRunner;
import org.openbravo.erpCommon.businessUtility.WindowTabs;
import org.openbravo.xmlEngine.XmlDocument;
import java.util.Vector;
import java.util.StringTokenizer;
import org.openbravo.database.SessionInfo;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.sql.Connection;
import org.apache.log4j.Logger;

public class BankStatementLines extends HttpSecureAppServlet {
  private static final long serialVersionUID = 1L;
  
  private static Logger log4j = Logger.getLogger(BankStatementLines.class);
  
  private static final String windowId = "94EAA455D2644E04AB25D93BE5157B6D";
  private static final String tabId = "7F5E8E4C55914138A358F5087B532B59";
  private static final String defaultTabView = "RELATION";
  private static final int accesslevel = 1;
  private static final String moduleId = "0";
  
  @Override
  public void init(ServletConfig config) {
    setClassInfo("W", tabId, moduleId);
    super.init(config);
  }
  
  

  public void doPost (HttpServletRequest request, HttpServletResponse response) throws IOException,ServletException {
    TableSQLData tableSQL = null;
    VariablesSecureApp vars = new VariablesSecureApp(request);
    Boolean saveRequest = (Boolean) request.getAttribute("autosave");
    
    if(saveRequest != null && saveRequest){
      String currentOrg = vars.getStringParameter("inpadOrgId");
      String currentClient = vars.getStringParameter("inpadClientId");
      boolean editableTab = (!org.openbravo.erpCommon.utility.WindowAccessData.hasReadOnlyAccess(this, vars.getRole(), tabId)
                            && (currentOrg.equals("") || Utility.isElementInList(Utility.getContext(this, vars,"#User_Org", windowId, accesslevel), currentOrg)) 
                            && (currentClient.equals("") || Utility.isElementInList(Utility.getContext(this, vars, "#User_Client", windowId, accesslevel),currentClient)));
    
        OBError myError = new OBError();
        String commandType = request.getParameter("inpCommandType");
        String strfinBankstatementlineId = request.getParameter("inpfinBankstatementlineId");
         String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");
        if (editableTab) {
          int total = 0;
          
          if(commandType.equalsIgnoreCase("EDIT") && !strfinBankstatementlineId.equals(""))
              total = saveRecord(vars, myError, 'U', strPFIN_Bankstatement_ID);
          else
              total = saveRecord(vars, myError, 'I', strPFIN_Bankstatement_ID);
          
          if (!myError.isEmpty() && total == 0)     
            throw new OBException(myError.getMessage());
        }
        vars.setSessionValue(request.getParameter("mappingName") +"|hash", vars.getPostDataHash());
        vars.setSessionValue(tabId + "|Header.view", "EDIT");
        
        return;
    }
    
    try {
      tableSQL = new TableSQLData(vars, this, tabId, Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel), Utility.getContext(this, vars, "#User_Client", windowId), Utility.getContext(this, vars, "ShowAudit", windowId).equals("Y"));
    } catch (Exception ex) {
      ex.printStackTrace();
    }

    String strOrderBy = vars.getSessionValue(tabId + "|orderby");
    if (!strOrderBy.equals("")) {
      vars.setSessionValue(tabId + "|newOrder", "1");
    }

    if (vars.commandIn("DEFAULT")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID", "");

      String strFIN_Bankstatementline_ID = vars.getGlobalVariable("inpfinBankstatementlineId", windowId + "|FIN_Bankstatementline_ID", "");
            if (strPFIN_Bankstatement_ID.equals("")) {
        strPFIN_Bankstatement_ID = getParentID(vars, strFIN_Bankstatementline_ID);
        if (strPFIN_Bankstatement_ID.equals("")) throw new ServletException("Required parameter :" + windowId + "|FIN_Bankstatement_ID");
        vars.setSessionValue(windowId + "|FIN_Bankstatement_ID", strPFIN_Bankstatement_ID);
      vars.removeSessionValue(windowId + "|FIN_Financial_Account_ID");
        refreshParentSession(vars, strPFIN_Bankstatement_ID);
      }


      String strView = vars.getSessionValue(tabId + "|BankStatementLines.view");
      if (strView.equals("")) {
        strView = defaultTabView;

        if (strView.equals("EDIT")) {
          if (strFIN_Bankstatementline_ID.equals("")) strFIN_Bankstatementline_ID = firstElement(vars, tableSQL);
          if (strFIN_Bankstatementline_ID.equals("")) strView = "RELATION";
        }
      }
      if (strView.equals("EDIT")) 

        printPageEdit(response, request, vars, false, strFIN_Bankstatementline_ID, strPFIN_Bankstatement_ID, tableSQL);

      else printPageDataSheet(response, vars, strPFIN_Bankstatement_ID, strFIN_Bankstatementline_ID, tableSQL);
    } else if (vars.commandIn("DIRECT")) {
      String strFIN_Bankstatementline_ID = vars.getStringParameter("inpDirectKey");
      
        
      if (strFIN_Bankstatementline_ID.equals("")) strFIN_Bankstatementline_ID = vars.getRequiredGlobalVariable("inpfinBankstatementlineId", windowId + "|FIN_Bankstatementline_ID");
      else vars.setSessionValue(windowId + "|FIN_Bankstatementline_ID", strFIN_Bankstatementline_ID);
      
      
      String strPFIN_Bankstatement_ID = getParentID(vars, strFIN_Bankstatementline_ID);
      
      vars.setSessionValue(windowId + "|FIN_Bankstatement_ID", strPFIN_Bankstatement_ID);
      vars.setSessionValue("C56E698100314ABBBBD3A89626CA551C|Imported Bank Statements.view", "EDIT");
      vars.removeSessionValue(windowId + "|FIN_Financial_Account_ID");
      refreshParentSession(vars, strPFIN_Bankstatement_ID);

      vars.setSessionValue(tabId + "|BankStatementLines.view", "EDIT");

      printPageEdit(response, request, vars, false, strFIN_Bankstatementline_ID, strPFIN_Bankstatement_ID, tableSQL);

    } else if (vars.commandIn("TAB")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID", false, false, true, "");
      vars.removeSessionValue(windowId + "|FIN_Bankstatementline_ID");
      refreshParentSession(vars, strPFIN_Bankstatement_ID);


      String strView = vars.getSessionValue(tabId + "|BankStatementLines.view");
      String strFIN_Bankstatementline_ID = "";
      if (strView.equals("")) {
        strView = defaultTabView;
        if (strView.equals("EDIT")) {
          strFIN_Bankstatementline_ID = firstElement(vars, tableSQL);
          if (strFIN_Bankstatementline_ID.equals("")) strView = "RELATION";
        }
      }
      if (strView.equals("EDIT")) {

        if (strFIN_Bankstatementline_ID.equals("")) strFIN_Bankstatementline_ID = firstElement(vars, tableSQL);
        printPageEdit(response, request, vars, false, strFIN_Bankstatementline_ID, strPFIN_Bankstatement_ID, tableSQL);

      } else printPageDataSheet(response, vars, strPFIN_Bankstatement_ID, "", tableSQL);
    } else if (vars.commandIn("SEARCH")) {
vars.getRequestGlobalVariable("inpParamBpartnername", tabId + "|paramBpartnername");
vars.getRequestGlobalVariable("inpParamC_Bpartner_ID", tabId + "|paramC_Bpartner_ID");
vars.getRequestGlobalVariable("inpParamDatetrx", tabId + "|paramDatetrx");
vars.getRequestGlobalVariable("inpParamCramount", tabId + "|paramCramount");
vars.getRequestGlobalVariable("inpParamDramount", tabId + "|paramDramount");
vars.getRequestGlobalVariable("inpParamReferenceno", tabId + "|paramReferenceno");
vars.getRequestGlobalVariable("inpParamDatetrx_f", tabId + "|paramDatetrx_f");
vars.getRequestGlobalVariable("inpParamCramount_f", tabId + "|paramCramount_f");
vars.getRequestGlobalVariable("inpParamDramount_f", tabId + "|paramDramount_f");

        vars.getRequestGlobalVariable("inpParamUpdated", tabId + "|paramUpdated");
        vars.getRequestGlobalVariable("inpParamUpdatedBy", tabId + "|paramUpdatedBy");
        vars.getRequestGlobalVariable("inpParamCreated", tabId + "|paramCreated");
        vars.getRequestGlobalVariable("inpparamCreatedBy", tabId + "|paramCreatedBy");
            String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");

      
      vars.removeSessionValue(windowId + "|FIN_Bankstatementline_ID");
      String strFIN_Bankstatementline_ID="";

      String strView = vars.getSessionValue(tabId + "|BankStatementLines.view");
      if (strView.equals("")) strView=defaultTabView;

      if (strView.equals("EDIT")) {
        strFIN_Bankstatementline_ID = firstElement(vars, tableSQL);
        if (strFIN_Bankstatementline_ID.equals("")) {
          // filter returns empty set
          strView = "RELATION";
          // switch to grid permanently until the user changes the view again
          vars.setSessionValue(tabId + "|BankStatementLines.view", strView);
        }
      }

      if (strView.equals("EDIT")) 

        printPageEdit(response, request, vars, false, strFIN_Bankstatementline_ID, strPFIN_Bankstatement_ID, tableSQL);

      else printPageDataSheet(response, vars, strPFIN_Bankstatement_ID, strFIN_Bankstatementline_ID, tableSQL);
    } else if (vars.commandIn("RELATION")) {
            String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");
      

      String strFIN_Bankstatementline_ID = vars.getGlobalVariable("inpfinBankstatementlineId", windowId + "|FIN_Bankstatementline_ID", "");
      vars.setSessionValue(tabId + "|BankStatementLines.view", "RELATION");
      printPageDataSheet(response, vars, strPFIN_Bankstatement_ID, strFIN_Bankstatementline_ID, tableSQL);
    } else if (vars.commandIn("NEW")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");


      printPageEdit(response, request, vars, true, "", strPFIN_Bankstatement_ID, tableSQL);

    } else if (vars.commandIn("EDIT")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");

      @SuppressWarnings("unused") // In Expense Invoice tab this variable is not used, to be fixed
      String strFIN_Bankstatementline_ID = vars.getGlobalVariable("inpfinBankstatementlineId", windowId + "|FIN_Bankstatementline_ID", "");
      vars.setSessionValue(tabId + "|BankStatementLines.view", "EDIT");

      setHistoryCommand(request, "EDIT");
      printPageEdit(response, request, vars, false, strFIN_Bankstatementline_ID, strPFIN_Bankstatement_ID, tableSQL);

    } else if (vars.commandIn("NEXT")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");
      String strFIN_Bankstatementline_ID = vars.getRequiredStringParameter("inpfinBankstatementlineId");
      
      String strNext = nextElement(vars, strFIN_Bankstatementline_ID, tableSQL);

      printPageEdit(response, request, vars, false, strNext, strPFIN_Bankstatement_ID, tableSQL);
    } else if (vars.commandIn("PREVIOUS")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");
      String strFIN_Bankstatementline_ID = vars.getRequiredStringParameter("inpfinBankstatementlineId");
      
      String strPrevious = previousElement(vars, strFIN_Bankstatementline_ID, tableSQL);

      printPageEdit(response, request, vars, false, strPrevious, strPFIN_Bankstatement_ID, tableSQL);
    } else if (vars.commandIn("FIRST_RELATION")) {
vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");

      vars.setSessionValue(tabId + "|BankStatementLines.initRecordNumber", "0");
      response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
    } else if (vars.commandIn("PREVIOUS_RELATION")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");

      String strInitRecord = vars.getSessionValue(tabId + "|BankStatementLines.initRecordNumber");
      String strRecordRange = Utility.getContext(this, vars, "#RecordRange", windowId);
      int intRecordRange = strRecordRange.equals("")?0:Integer.parseInt(strRecordRange);
      if (strInitRecord.equals("") || strInitRecord.equals("0")) {
        vars.setSessionValue(tabId + "|BankStatementLines.initRecordNumber", "0");
      } else {
        int initRecord = (strInitRecord.equals("")?0:Integer.parseInt(strInitRecord));
        initRecord -= intRecordRange;
        strInitRecord = ((initRecord<0)?"0":Integer.toString(initRecord));
        vars.setSessionValue(tabId + "|BankStatementLines.initRecordNumber", strInitRecord);
      }
      vars.removeSessionValue(windowId + "|FIN_Bankstatementline_ID");
      vars.setSessionValue(windowId + "|FIN_Bankstatement_ID", strPFIN_Bankstatement_ID);
      response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
    } else if (vars.commandIn("NEXT_RELATION")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");

      String strInitRecord = vars.getSessionValue(tabId + "|BankStatementLines.initRecordNumber");
      String strRecordRange = Utility.getContext(this, vars, "#RecordRange", windowId);
      int intRecordRange = strRecordRange.equals("")?0:Integer.parseInt(strRecordRange);
      int initRecord = (strInitRecord.equals("")?0:Integer.parseInt(strInitRecord));
      if (initRecord==0) initRecord=1;
      initRecord += intRecordRange;
      strInitRecord = ((initRecord<0)?"0":Integer.toString(initRecord));
      vars.setSessionValue(tabId + "|BankStatementLines.initRecordNumber", strInitRecord);
      vars.removeSessionValue(windowId + "|FIN_Bankstatementline_ID");
      vars.setSessionValue(windowId + "|FIN_Bankstatement_ID", strPFIN_Bankstatement_ID);
      response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
    } else if (vars.commandIn("FIRST")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");
      
      String strFirst = firstElement(vars, tableSQL);

      printPageEdit(response, request, vars, false, strFirst, strPFIN_Bankstatement_ID, tableSQL);
    } else if (vars.commandIn("LAST_RELATION")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");

      String strLast = lastElement(vars, tableSQL);
      printPageDataSheet(response, vars, strPFIN_Bankstatement_ID, strLast, tableSQL);
    } else if (vars.commandIn("LAST")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");
      
      String strLast = lastElement(vars, tableSQL);

      printPageEdit(response, request, vars, false, strLast, strPFIN_Bankstatement_ID, tableSQL);
    } else if (vars.commandIn("SAVE_NEW_RELATION", "SAVE_NEW_NEW", "SAVE_NEW_EDIT")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");
      OBError myError = new OBError();      
      int total = saveRecord(vars, myError, 'I', strPFIN_Bankstatement_ID);      
      if (!myError.isEmpty()) {        
        response.sendRedirect(strDireccion + request.getServletPath() + "?Command=NEW");
      } 
      else {
		if (myError.isEmpty()) {
		  myError = Utility.translateError(this, vars, vars.getLanguage(), "@CODE=RowsInserted");
		  myError.setMessage(total + " " + myError.getMessage());
		  vars.setMessage(tabId, myError);
		}        
        if (vars.commandIn("SAVE_NEW_NEW")) response.sendRedirect(strDireccion + request.getServletPath() + "?Command=NEW");
        else if (vars.commandIn("SAVE_NEW_EDIT")) response.sendRedirect(strDireccion + request.getServletPath() + "?Command=EDIT");
        else response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
      }
    } else if (vars.commandIn("SAVE_EDIT_RELATION", "SAVE_EDIT_NEW", "SAVE_EDIT_EDIT", "SAVE_EDIT_NEXT")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");
      String strFIN_Bankstatementline_ID = vars.getRequiredGlobalVariable("inpfinBankstatementlineId", windowId + "|FIN_Bankstatementline_ID");
      OBError myError = new OBError();
      int total = saveRecord(vars, myError, 'U', strPFIN_Bankstatement_ID);      
      if (!myError.isEmpty()) {
        response.sendRedirect(strDireccion + request.getServletPath() + "?Command=EDIT");
      } 
      else {
        if (myError.isEmpty()) {
          myError = Utility.translateError(this, vars, vars.getLanguage(), "@CODE=RowsUpdated");
          myError.setMessage(total + " " + myError.getMessage());
          vars.setMessage(tabId, myError);
        }
        if (vars.commandIn("SAVE_EDIT_NEW")) response.sendRedirect(strDireccion + request.getServletPath() + "?Command=NEW");
        else if (vars.commandIn("SAVE_EDIT_EDIT")) response.sendRedirect(strDireccion + request.getServletPath() + "?Command=EDIT");
        else if (vars.commandIn("SAVE_EDIT_NEXT")) {
          String strNext = nextElement(vars, strFIN_Bankstatementline_ID, tableSQL);
          vars.setSessionValue(windowId + "|FIN_Bankstatementline_ID", strNext);
          response.sendRedirect(strDireccion + request.getServletPath() + "?Command=EDIT");
        } else response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
      }
    } else if (vars.commandIn("DELETE")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");

      String strFIN_Bankstatementline_ID = vars.getRequiredStringParameter("inpfinBankstatementlineId");
      //BankStatementLinesData data = getEditVariables(vars, strPFIN_Bankstatement_ID);
      int total = 0;
      OBError myError = null;
      if (org.openbravo.erpCommon.utility.WindowAccessData.hasNotDeleteAccess(this, vars.getRole(), tabId)) {
        myError = Utility.translateError(this, vars, vars.getLanguage(), Utility.messageBD(this, "NoWriteAccess", vars.getLanguage()));
        vars.setMessage(tabId, myError);
      } else {
        try {
          total = BankStatementLinesData.delete(this, strFIN_Bankstatementline_ID, strPFIN_Bankstatement_ID, Utility.getContext(this, vars, "#User_Client", windowId, accesslevel), Utility.getContext(this, vars, "#User_Org", windowId, accesslevel));
        } catch(ServletException ex) {
          myError = Utility.translateError(this, vars, vars.getLanguage(), ex.getMessage());
          if (!myError.isConnectionAvailable()) {
            bdErrorConnection(response);
            return;
          } else vars.setMessage(tabId, myError);
        }
        if (myError==null && total==0) {
          myError = Utility.translateError(this, vars, vars.getLanguage(), Utility.messageBD(this, "NoWriteAccess", vars.getLanguage()));
          vars.setMessage(tabId, myError);
        }
        vars.removeSessionValue(windowId + "|finBankstatementlineId");
        vars.setSessionValue(tabId + "|BankStatementLines.view", "RELATION");
      }
      if (myError==null) {
        myError = Utility.translateError(this, vars, vars.getLanguage(), "@CODE=RowsDeleted");
        myError.setMessage(total + " " + myError.getMessage());
        vars.setMessage(tabId, myError);
      }
      response.sendRedirect(strDireccion + request.getServletPath());








    } else if (vars.commandIn("SAVE_XHR")) {
      String strPFIN_Bankstatement_ID = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");
      OBError myError = new OBError();
      JSONObject result = new JSONObject();
      String commandType = vars.getStringParameter("inpCommandType");
      char saveType = "NEW".equals(commandType) ? 'I' : 'U';
      try {
        int total = saveRecord(vars, myError, saveType, strPFIN_Bankstatement_ID);
        if (myError.isEmpty()) {
          myError = Utility.translateError(this, vars, vars.getLanguage(), "@CODE=RowsUpdated");
          myError.setMessage(total + " " + myError.getMessage());
          myError.setType("Success");
        }
        result.put("oberror", myError.toMap());
        result.put("tabid", vars.getStringParameter("tabID"));
        result.put("redirect", strDireccion + request.getServletPath() + "?Command=" + commandType);
      } catch (Exception e) {
        log4j.error("Error saving record (XHR request): " + e.getMessage(), e);
        myError.setType("Error");
        myError.setMessage(e.getMessage());
      }

      response.setContentType("application/json");
      PrintWriter out = response.getWriter();
      out.print(result.toString());
      out.flush();
      out.close();
    } else if (vars.getCommand().toUpperCase().startsWith("BUTTON") || vars.getCommand().toUpperCase().startsWith("SAVE_BUTTON")) {
      pageErrorPopUp(response);
    } else pageError(response);
  }
  private BankStatementLinesData getEditVariables(Connection con, VariablesSecureApp vars, String strPFIN_Bankstatement_ID) throws IOException,ServletException {
    BankStatementLinesData data = new BankStatementLinesData();
    ServletException ex = null;
    try {
    data.isactive = vars.getStringParameter("inpisactive", "N");    try {   data.line = vars.getRequiredNumericParameter("inpline");  } catch (ServletException paramEx) { ex = paramEx; }     data.datetrx = vars.getRequiredStringParameter("inpdatetrx");     data.referenceno = vars.getRequiredStringParameter("inpreferenceno");     data.bpartnername = vars.getStringParameter("inpbpartnername");     data.cBpartnerId = vars.getStringParameter("inpcBpartnerId");     data.cBpartnerIdr = vars.getStringParameter("inpcBpartnerId_R");    try {   data.dramount = vars.getRequiredNumericParameter("inpdramount");  } catch (ServletException paramEx) { ex = paramEx; }    try {   data.cramount = vars.getRequiredNumericParameter("inpcramount");  } catch (ServletException paramEx) { ex = paramEx; }     data.finFinaccTransactionId = vars.getStringParameter("inpfinFinaccTransactionId");     data.finFinaccTransactionIdr = vars.getStringParameter("inpfinFinaccTransactionId_R");     data.matchingtype = vars.getStringParameter("inpmatchingtype");     data.matchingtyper = vars.getStringParameter("inpmatchingtype_R");     data.description = vars.getStringParameter("inpdescription");     data.adClientId = vars.getRequiredGlobalVariable("inpadClientId", windowId + "|AD_Client_ID");     data.finBankstatementlineId = vars.getRequestGlobalVariable("inpfinBankstatementlineId", windowId + "|FIN_Bankstatementline_ID");     data.finBankstatementId = vars.getRequiredStringParameter("inpfinBankstatementId");     data.adOrgId = vars.getRequiredGlobalVariable("inpadOrgId", windowId + "|AD_Org_ID"); 
      data.createdby = vars.getUser();
      data.updatedby = vars.getUser();
      data.adUserClient = Utility.getContext(this, vars, "#User_Client", windowId, accesslevel);
      data.adOrgClient = Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel);
      data.updatedTimeStamp = vars.getStringParameter("updatedTimestamp");

      data.finBankstatementId = vars.getGlobalVariable("inpfinBankstatementId", windowId + "|FIN_Bankstatement_ID");


          vars.getGlobalVariable("inpaprmBsprocessed", windowId + "|APRM_BSProcessed", "");
    
    

    
    }
    catch(ServletException e) {
    	vars.setEditionData(tabId, data);
    	throw e;
    }
    // Behavior with exception for numeric fields is to catch last one if we have multiple ones
    if(ex != null) {
      vars.setEditionData(tabId, data);
      throw ex;
    }
    return data;
  }


  private void refreshParentSession(VariablesSecureApp vars, String strPFIN_Bankstatement_ID) throws IOException,ServletException {
      
      ImportedBankStatementsData[] data = ImportedBankStatementsData.selectEdit(this, vars.getSessionValue("#AD_SqlDateTimeFormat"), vars.getLanguage(), vars.getSessionValue(windowId + "|FIN_Financial_Account_ID"), strPFIN_Bankstatement_ID, Utility.getContext(this, vars, "#User_Client", windowId), Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel));
      if (data==null || data.length==0) return;
          vars.setSessionValue(windowId + "|EM_APRM_Process_BS", data[0].emAprmProcessBs);    vars.setSessionValue(windowId + "|FIN_Bankstatement_ID", data[0].finBankstatementId);    vars.setSessionValue(windowId + "|AD_Org_ID", data[0].adOrgId);    vars.setSessionValue(windowId + "|AD_Client_ID", data[0].adClientId);
      vars.setSessionValue(windowId + "|FIN_Bankstatement_ID", strPFIN_Bankstatement_ID); //to ensure key parent is set for EM_* cols

      FieldProvider dataField = null; // Define this so that auxiliar inputs using SQL will work
      
  }
  
  
  private String getParentID(VariablesSecureApp vars, String strFIN_Bankstatementline_ID) throws ServletException {
    String strPFIN_Bankstatement_ID = BankStatementLinesData.selectParentID(this, strFIN_Bankstatementline_ID);
    if (strPFIN_Bankstatement_ID.equals("")) {
      log4j.error("Parent record not found for id: " + strFIN_Bankstatementline_ID);
      throw new ServletException("Parent record not found");
    }
    return strPFIN_Bankstatement_ID;
  }

    private void refreshSessionEdit(VariablesSecureApp vars, FieldProvider[] data) {
      if (data==null || data.length==0) return;
          vars.setSessionValue(windowId + "|FIN_Bankstatementline_ID", data[0].getField("finBankstatementlineId"));    vars.setSessionValue(windowId + "|AD_Org_ID", data[0].getField("adOrgId"));    vars.setSessionValue(windowId + "|AD_Client_ID", data[0].getField("adClientId"));
    }

    private void refreshSessionNew(VariablesSecureApp vars, String strPFIN_Bankstatement_ID) throws IOException,ServletException {
      BankStatementLinesData[] data = BankStatementLinesData.selectEdit(this, vars.getSessionValue("#AD_SqlDateTimeFormat"), vars.getLanguage(), strPFIN_Bankstatement_ID, vars.getStringParameter("inpfinBankstatementlineId", ""), Utility.getContext(this, vars, "#User_Client", windowId), Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel));
      if (data==null || data.length==0) return;
      refreshSessionEdit(vars, data);
    }

  private String nextElement(VariablesSecureApp vars, String strSelected, TableSQLData tableSQL) throws IOException, ServletException {
    if (strSelected == null || strSelected.equals("")) return firstElement(vars, tableSQL);
    if (tableSQL!=null) {
      String data = null;
      try{
        String strSQL = ModelSQLGeneration.generateSQLonlyId(this, vars, tableSQL, (tableSQL.getTableName() + "." + tableSQL.getKeyColumn() + " AS ID"), new Vector<String>(), new Vector<String>(), 0, 0);
        ExecuteQuery execquery = new ExecuteQuery(this, strSQL, tableSQL.getParameterValuesOnlyId());
        data = execquery.selectAndSearch(ExecuteQuery.SearchType.NEXT, strSelected, tableSQL.getKeyColumn());
      } catch (Exception e) { 
        log4j.error("Error getting next element", e);
      }
      if (data!=null) {
        if (data!=null) return data;
      }
    }
    return strSelected;
  }

  private int getKeyPosition(VariablesSecureApp vars, String strSelected, TableSQLData tableSQL) throws IOException, ServletException {
    if (log4j.isDebugEnabled()) log4j.debug("getKeyPosition: " + strSelected);
    if (tableSQL!=null) {
      String data = null;
      try{
        String strSQL = ModelSQLGeneration.generateSQLonlyId(this, vars, tableSQL, (tableSQL.getTableName() + "." + tableSQL.getKeyColumn() + " AS ID"), new Vector<String>(), new Vector<String>(),0,0);
        ExecuteQuery execquery = new ExecuteQuery(this, strSQL, tableSQL.getParameterValuesOnlyId());
        data = execquery.selectAndSearch(ExecuteQuery.SearchType.GETPOSITION, strSelected, tableSQL.getKeyColumn());
      } catch (Exception e) { 
        log4j.error("Error getting key position", e);
      }
      if (data!=null) {
        // split offset -> (page,relativeOffset)
        int absoluteOffset = Integer.valueOf(data);
        int page = absoluteOffset / TableSQLData.maxRowsPerGridPage;
        int relativeOffset = absoluteOffset % TableSQLData.maxRowsPerGridPage;
        log4j.debug("getKeyPosition: absOffset: " + absoluteOffset + "=> page: " + page + " relOffset: " + relativeOffset);
        String currPageKey = tabId + "|" + "currentPage";
        vars.setSessionValue(currPageKey, String.valueOf(page));
        return relativeOffset;
      }
    }
    return 0;
  }

  private String previousElement(VariablesSecureApp vars, String strSelected, TableSQLData tableSQL) throws IOException, ServletException {
    if (strSelected == null || strSelected.equals("")) return firstElement(vars, tableSQL);
    if (tableSQL!=null) {
      String data = null;
      try{
        String strSQL = ModelSQLGeneration.generateSQLonlyId(this, vars, tableSQL, (tableSQL.getTableName() + "." + tableSQL.getKeyColumn() + " AS ID"), new Vector<String>(), new Vector<String>(),0,0);
        ExecuteQuery execquery = new ExecuteQuery(this, strSQL, tableSQL.getParameterValuesOnlyId());
        data = execquery.selectAndSearch(ExecuteQuery.SearchType.PREVIOUS, strSelected, tableSQL.getKeyColumn());
      } catch (Exception e) { 
        log4j.error("Error getting previous element", e);
      }
      if (data!=null) {
        return data;
      }
    }
    return strSelected;
  }

  private String firstElement(VariablesSecureApp vars, TableSQLData tableSQL) throws IOException, ServletException {
    if (tableSQL!=null) {
      String data = null;
      try{
        String strSQL = ModelSQLGeneration.generateSQLonlyId(this, vars, tableSQL, (tableSQL.getTableName() + "." + tableSQL.getKeyColumn() + " AS ID"), new Vector<String>(), new Vector<String>(),0,1);
        ExecuteQuery execquery = new ExecuteQuery(this, strSQL, tableSQL.getParameterValuesOnlyId());
        data = execquery.selectAndSearch(ExecuteQuery.SearchType.FIRST, "", tableSQL.getKeyColumn());

      } catch (Exception e) { 
        log4j.debug("Error getting first element", e);
      }
      if (data!=null) return data;
    }
    return "";
  }

  private String lastElement(VariablesSecureApp vars, TableSQLData tableSQL) throws IOException, ServletException {
    if (tableSQL!=null) {
      String data = null;
      try{
        String strSQL = ModelSQLGeneration.generateSQLonlyId(this, vars, tableSQL, (tableSQL.getTableName() + "." + tableSQL.getKeyColumn() + " AS ID"), new Vector<String>(), new Vector<String>(),0,0);
        ExecuteQuery execquery = new ExecuteQuery(this, strSQL, tableSQL.getParameterValuesOnlyId());
        data = execquery.selectAndSearch(ExecuteQuery.SearchType.LAST, "", tableSQL.getKeyColumn());
      } catch (Exception e) { 
        log4j.error("Error getting last element", e);
      }
      if (data!=null) return data;
    }
    return "";
  }

  private void printPageDataSheet(HttpServletResponse response, VariablesSecureApp vars, String strPFIN_Bankstatement_ID, String strFIN_Bankstatementline_ID, TableSQLData tableSQL)
    throws IOException, ServletException {
    if (log4j.isDebugEnabled()) log4j.debug("Output: dataSheet");

    String strParamBpartnername = vars.getSessionValue(tabId + "|paramBpartnername");
String strParamC_Bpartner_ID = vars.getSessionValue(tabId + "|paramC_Bpartner_ID");
String strParamDatetrx = vars.getSessionValue(tabId + "|paramDatetrx");
String strParamCramount = vars.getSessionValue(tabId + "|paramCramount");
String strParamDramount = vars.getSessionValue(tabId + "|paramDramount");
String strParamReferenceno = vars.getSessionValue(tabId + "|paramReferenceno");
String strParamDatetrx_f = vars.getSessionValue(tabId + "|paramDatetrx_f");
String strParamCramount_f = vars.getSessionValue(tabId + "|paramCramount_f");
String strParamDramount_f = vars.getSessionValue(tabId + "|paramDramount_f");

    boolean hasSearchCondition=false;
    vars.removeEditionData(tabId);
    hasSearchCondition = (tableSQL.hasInternalFilter() && ("").equals(strParamBpartnername) && ("").equals(strParamC_Bpartner_ID) && ("").equals(strParamDatetrx) && ("").equals(strParamCramount) && ("").equals(strParamDramount) && ("").equals(strParamReferenceno) && ("").equals(strParamDatetrx_f) && ("").equals(strParamCramount_f) && ("").equals(strParamDramount_f)) || !(("").equals(strParamBpartnername) || ("%").equals(strParamBpartnername))  || !(("").equals(strParamC_Bpartner_ID) || ("%").equals(strParamC_Bpartner_ID))  || !(("").equals(strParamDatetrx) || ("%").equals(strParamDatetrx))  || !(("").equals(strParamCramount) || ("%").equals(strParamCramount))  || !(("").equals(strParamDramount) || ("%").equals(strParamDramount))  || !(("").equals(strParamReferenceno) || ("%").equals(strParamReferenceno))  || !(("").equals(strParamDatetrx_f) || ("%").equals(strParamDatetrx_f))  || !(("").equals(strParamCramount_f) || ("%").equals(strParamCramount_f))  || !(("").equals(strParamDramount_f) || ("%").equals(strParamDramount_f)) ;
    String strOffset = vars.getSessionValue(tabId + "|offset");
    String selectedRow = "0";
    if (!strFIN_Bankstatementline_ID.equals("")) {
      selectedRow = Integer.toString(getKeyPosition(vars, strFIN_Bankstatementline_ID, tableSQL));
    }

    String[] discard={"isNotFiltered","isNotTest"};
    if (hasSearchCondition) discard[0] = new String("isFiltered");
    if (vars.getSessionValue("#ShowTest", "N").equals("Y")) discard[1] = new String("isTest");
    XmlDocument xmlDocument = xmlEngine.readXmlTemplate("org/openbravo/erpWindows/FinancialAccount/BankStatementLines_Relation", discard).createXmlDocument();

    boolean hasReadOnlyAccess = org.openbravo.erpCommon.utility.WindowAccessData.hasReadOnlyAccess(this, vars.getRole(), tabId);
    ToolBar toolbar = new ToolBar(this, true, vars.getLanguage(), "BankStatementLines", false, "document.frmMain.inpfinBankstatementlineId", "grid", "..", "".equals("Y"), "FinancialAccount", strReplaceWith, false, false, false, false, !hasReadOnlyAccess);
    toolbar.setTabId(tabId);
    
    toolbar.setDeleteable(true && !hasReadOnlyAccess);
    toolbar.prepareRelationTemplate("N".equals("Y"), hasSearchCondition, !vars.getSessionValue("#ShowTest", "N").equals("Y"), false, Utility.getContext(this, vars, "ShowAudit", windowId).equals("Y"));
    xmlDocument.setParameter("toolbar", toolbar.toString());

    xmlDocument.setParameter("keyParent", strPFIN_Bankstatement_ID);
    xmlDocument.setParameter("parentFieldName", Utility.getFieldName("82B7B2BAEDFC4980E040007F010008E7", vars.getLanguage()));


    StringBuffer orderByArray = new StringBuffer();
      vars.setSessionValue(tabId + "|newOrder", "1");
      String positions = vars.getSessionValue(tabId + "|orderbyPositions");
      orderByArray.append("var orderByPositions = new Array(\n");
      if (!positions.equals("")) {
        StringTokenizer tokens=new StringTokenizer(positions, ",");
        boolean firstOrder = true;
        while(tokens.hasMoreTokens()){
          if (!firstOrder) orderByArray.append(",\n");
          orderByArray.append("\"").append(tokens.nextToken()).append("\"");
          firstOrder = false;
        }
      }
      orderByArray.append(");\n");
      String directions = vars.getSessionValue(tabId + "|orderbyDirections");
      orderByArray.append("var orderByDirections = new Array(\n");
      if (!positions.equals("")) {
        StringTokenizer tokens=new StringTokenizer(directions, ",");
        boolean firstOrder = true;
        while(tokens.hasMoreTokens()){
          if (!firstOrder) orderByArray.append(",\n");
          orderByArray.append("\"").append(tokens.nextToken()).append("\"");
          firstOrder = false;
        }
      }
      orderByArray.append(");\n");
//    }

    xmlDocument.setParameter("selectedColumn", "\nvar selectedRow = " + selectedRow + ";\n" + orderByArray.toString());
    xmlDocument.setParameter("directory", "var baseDirectory = \"" + strReplaceWith + "/\";\n");
    xmlDocument.setParameter("windowId", windowId);
    xmlDocument.setParameter("KeyName", "finBankstatementlineId");
    xmlDocument.setParameter("language", "defaultLang=\"" + vars.getLanguage() + "\";");
    xmlDocument.setParameter("theme", vars.getTheme());
    //xmlDocument.setParameter("buttonReference", Utility.messageBD(this, "Reference", vars.getLanguage()));
    try {
      WindowTabs tabs = new WindowTabs(this, vars, tabId, windowId, false);
      xmlDocument.setParameter("parentTabContainer", tabs.parentTabs());
      xmlDocument.setParameter("mainTabContainer", tabs.mainTabs());
      xmlDocument.setParameter("childTabContainer", tabs.childTabs());
      String hideBackButton = vars.getGlobalVariable("hideMenu", "#Hide_BackButton", "");
      NavigationBar nav = new NavigationBar(this, vars.getLanguage(), "BankStatementLines_Relation.html", "FinancialAccount", "W", strReplaceWith, tabs.breadcrumb(), hideBackButton.equals("true"));
      xmlDocument.setParameter("navigationBar", nav.toString());
      LeftTabsBar lBar = new LeftTabsBar(this, vars.getLanguage(), "BankStatementLines_Relation.html", strReplaceWith);
      xmlDocument.setParameter("leftTabs", lBar.relationTemplate());
    } catch (Exception ex) {
      throw new ServletException(ex);
    }
    {
      OBError myMessage = vars.getMessage(tabId);
      vars.removeMessage(tabId);
      if (myMessage!=null) {
        xmlDocument.setParameter("messageType", myMessage.getType());
        xmlDocument.setParameter("messageTitle", myMessage.getTitle());
        xmlDocument.setParameter("messageMessage", myMessage.getMessage());
      }
    }
    if (vars.getLanguage().equals("en_US")) xmlDocument.setParameter("parent", BankStatementLinesData.selectParent(this, strPFIN_Bankstatement_ID));
    else xmlDocument.setParameter("parent", BankStatementLinesData.selectParentTrl(this, strPFIN_Bankstatement_ID));

    xmlDocument.setParameter("grid", Utility.getContext(this, vars, "#RecordRange", windowId));
xmlDocument.setParameter("grid_Offset", strOffset);
xmlDocument.setParameter("grid_SortCols", positions);
xmlDocument.setParameter("grid_SortDirs", directions);
xmlDocument.setParameter("grid_Default", selectedRow);


    response.setContentType("text/html; charset=UTF-8");
    PrintWriter out = response.getWriter();
    out.println(xmlDocument.print());
    out.close();
  }

  private void printPageEdit(HttpServletResponse response, HttpServletRequest request, VariablesSecureApp vars,boolean boolNew, String strFIN_Bankstatementline_ID, String strPFIN_Bankstatement_ID, TableSQLData tableSQL)
    throws IOException, ServletException {
    if (log4j.isDebugEnabled()) log4j.debug("Output: edit");
    
    HashMap<String, String> usedButtonShortCuts;
  
    usedButtonShortCuts = new HashMap<String, String>();
    
    
    
    String strOrderByFilter = vars.getSessionValue(tabId + "|orderby");
    String orderClause = " FIN_BankStatementLine.Line";
    if (strOrderByFilter==null || strOrderByFilter.equals("")) strOrderByFilter = orderClause;
    /*{
      if (!strOrderByFilter.equals("") && !orderClause.equals("")) strOrderByFilter += ", ";
      strOrderByFilter += orderClause;
    }*/
    
    
    String strCommand = null;
    BankStatementLinesData[] data=null;
    XmlDocument xmlDocument=null;
    FieldProvider dataField = vars.getEditionData(tabId);
    vars.removeEditionData(tabId);
    String strParamBpartnername = vars.getSessionValue(tabId + "|paramBpartnername");
String strParamC_Bpartner_ID = vars.getSessionValue(tabId + "|paramC_Bpartner_ID");
String strParamDatetrx = vars.getSessionValue(tabId + "|paramDatetrx");
String strParamCramount = vars.getSessionValue(tabId + "|paramCramount");
String strParamDramount = vars.getSessionValue(tabId + "|paramDramount");
String strParamReferenceno = vars.getSessionValue(tabId + "|paramReferenceno");
String strParamDatetrx_f = vars.getSessionValue(tabId + "|paramDatetrx_f");
String strParamCramount_f = vars.getSessionValue(tabId + "|paramCramount_f");
String strParamDramount_f = vars.getSessionValue(tabId + "|paramDramount_f");

    boolean hasSearchCondition=false;
    hasSearchCondition = (tableSQL.hasInternalFilter() && ("").equals(strParamBpartnername) && ("").equals(strParamC_Bpartner_ID) && ("").equals(strParamDatetrx) && ("").equals(strParamCramount) && ("").equals(strParamDramount) && ("").equals(strParamReferenceno) && ("").equals(strParamDatetrx_f) && ("").equals(strParamCramount_f) && ("").equals(strParamDramount_f)) || !(("").equals(strParamBpartnername) || ("%").equals(strParamBpartnername))  || !(("").equals(strParamC_Bpartner_ID) || ("%").equals(strParamC_Bpartner_ID))  || !(("").equals(strParamDatetrx) || ("%").equals(strParamDatetrx))  || !(("").equals(strParamCramount) || ("%").equals(strParamCramount))  || !(("").equals(strParamDramount) || ("%").equals(strParamDramount))  || !(("").equals(strParamReferenceno) || ("%").equals(strParamReferenceno))  || !(("").equals(strParamDatetrx_f) || ("%").equals(strParamDatetrx_f))  || !(("").equals(strParamCramount_f) || ("%").equals(strParamCramount_f))  || !(("").equals(strParamDramount_f) || ("%").equals(strParamDramount_f)) ;

       String strParamSessionDate = vars.getGlobalVariable("inpParamSessionDate", Utility.getTransactionalDate(this, vars, windowId), "");
      String buscador = "";
      String[] discard = {"", "isNotTest"};
      
      if (vars.getSessionValue("#ShowTest", "N").equals("Y")) discard[1] = new String("isTest");
    if (dataField==null) {
      if (!boolNew) {
        discard[0] = new String("newDiscard");
        data = BankStatementLinesData.selectEdit(this, vars.getSessionValue("#AD_SqlDateTimeFormat"), vars.getLanguage(), strPFIN_Bankstatement_ID, strFIN_Bankstatementline_ID, Utility.getContext(this, vars, "#User_Client", windowId), Utility.getContext(this, vars, "#AccessibleOrgTree", windowId, accesslevel));
  
        if (!strFIN_Bankstatementline_ID.equals("") && (data == null || data.length==0)) {
          response.sendRedirect(strDireccion + request.getServletPath() + "?Command=RELATION");
          return;
        }
        refreshSessionEdit(vars, data);
        strCommand = "EDIT";
      }

      if (boolNew || data==null || data.length==0) {
        discard[0] = new String ("editDiscard");
        strCommand = "NEW";
        data = new BankStatementLinesData[0];
      } else {
        discard[0] = new String ("newDiscard");
      }
    } else {
      if (dataField.getField("finBankstatementlineId") == null || dataField.getField("finBankstatementlineId").equals("")) {
        discard[0] = new String ("editDiscard");
        strCommand = "NEW";
        boolNew = true;
      } else {
        discard[0] = new String ("newDiscard");
        strCommand = "EDIT";
      }
    }
    
        String strAPRM_BSProcessed = BankStatementLinesData.selectAux9D630C9E4C734361BFB09B153EEE3BCB(this, strPFIN_Bankstatement_ID);
    vars.setSessionValue(windowId + "|APRM_BSProcessed", strAPRM_BSProcessed);
    
    
    if (dataField==null) {
      if (boolNew || data==null || data.length==0) {
        refreshSessionNew(vars, strPFIN_Bankstatement_ID);
        data = BankStatementLinesData.set(strPFIN_Bankstatement_ID, "", Utility.getDefault(this, vars, "AD_Client_ID", "@AD_CLIENT_ID@", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField), Utility.getDefault(this, vars, "AD_Org_ID", "@AD_ORG_ID@", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField), Utility.getDefault(this, vars, "Createdby", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField), BankStatementLinesData.selectDef8189F49FFEBD6E56E040007F01003E83_0(this, Utility.getDefault(this, vars, "Createdby", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField)), Utility.getDefault(this, vars, "Updatedby", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField), BankStatementLinesData.selectDef8189F49FFEBF6E56E040007F01003E83_1(this, Utility.getDefault(this, vars, "Updatedby", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField)), "Y", Utility.getDefault(this, vars, "Bpartnername", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField), Utility.getDefault(this, vars, "C_Bpartner_ID", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField), BankStatementLinesData.selectDef8189F49FFEC36E56E040007F01003E83_2(this, Utility.getDefault(this, vars, "C_Bpartner_ID", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField)), Utility.getDefault(this, vars, "Datetrx", "@#Date@", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField), Utility.getDefault(this, vars, "Cramount", "0", "94EAA455D2644E04AB25D93BE5157B6D", "0", dataField), Utility.getDefault(this, vars, "Dramount", "0", "94EAA455D2644E04AB25D93BE5157B6D", "0", dataField), Utility.getDefault(this, vars, "Referenceno", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField), Utility.getDefault(this, vars, "Matchingtype", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField), Utility.getDefault(this, vars, "FIN_FinAcc_Transaction_ID", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField), BankStatementLinesData.selectDef8189F49FFEC96E56E040007F01003E83_3(this, Utility.getDefault(this, vars, "FIN_FinAcc_Transaction_ID", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField)), BankStatementLinesData.selectDef8340585805C35071E040007F01001EE8(this, strPFIN_Bankstatement_ID), Utility.getDefault(this, vars, "Description", "", "94EAA455D2644E04AB25D93BE5157B6D", "", dataField));
        
      }
     }
      
    String currentPOrg=ImportedBankStatementsData.selectOrg(this, strPFIN_Bankstatement_ID);
    String currentOrg = (boolNew?"":(dataField!=null?dataField.getField("adOrgId"):data[0].getField("adOrgId")));
    if (!currentOrg.equals("") && !currentOrg.startsWith("'")) currentOrg = "'"+currentOrg+"'";
    String currentClient = (boolNew?"":(dataField!=null?dataField.getField("adClientId"):data[0].getField("adClientId")));
    if (!currentClient.equals("") && !currentClient.startsWith("'")) currentClient = "'"+currentClient+"'";
    
    boolean hasReadOnlyAccess = org.openbravo.erpCommon.utility.WindowAccessData.hasReadOnlyAccess(this, vars.getRole(), tabId);
    boolean editableTab = (!hasReadOnlyAccess && (currentOrg.equals("") || Utility.isElementInList(Utility.getContext(this, vars, "#User_Org", windowId, accesslevel),currentOrg)) && (currentClient.equals("") || Utility.isElementInList(Utility.getContext(this, vars, "#User_Client", windowId, accesslevel), currentClient)));
    if (editableTab)
      xmlDocument = xmlEngine.readXmlTemplate("org/openbravo/erpWindows/FinancialAccount/BankStatementLines_Edition",discard).createXmlDocument();
    else
      xmlDocument = xmlEngine.readXmlTemplate("org/openbravo/erpWindows/FinancialAccount/BankStatementLines_NonEditable",discard).createXmlDocument();

    xmlDocument.setParameter("tabId", tabId);
    ToolBar toolbar = new ToolBar(this, editableTab, vars.getLanguage(), "BankStatementLines", (strCommand.equals("NEW") || boolNew || (dataField==null && (data==null || data.length==0))), "document.frmMain.inpfinBankstatementlineId", "", "..", "".equals("Y"), "FinancialAccount", strReplaceWith, true, false, false, Utility.hasTabAttachments(this, vars, tabId, strFIN_Bankstatementline_ID), !hasReadOnlyAccess);
    toolbar.setTabId(tabId);
    toolbar.setDeleteable(true);
    toolbar.prepareEditionTemplate("N".equals("Y"), hasSearchCondition, vars.getSessionValue("#ShowTest", "N").equals("Y"), "STD", Utility.getContext(this, vars, "ShowAudit", windowId).equals("Y"));
    xmlDocument.setParameter("toolbar", toolbar.toString());

    // set updated timestamp to manage locking mechanism
    if (!boolNew) {
      xmlDocument.setParameter("updatedTimestamp", (dataField != null ? dataField
          .getField("updatedTimeStamp") : data[0].getField("updatedTimeStamp")));
    }
    
    boolean concurrentSave = vars.getSessionValue(tabId + "|concurrentSave").equals("true");
    if (concurrentSave) {
      //after concurrent save error, force autosave
      xmlDocument.setParameter("autosave", "Y");
    } else {
      xmlDocument.setParameter("autosave", "N");
    }
    vars.removeSessionValue(tabId + "|concurrentSave");

    try {
      WindowTabs tabs = new WindowTabs(this, vars, tabId, windowId, true, (strCommand.equalsIgnoreCase("NEW")));
      xmlDocument.setParameter("parentTabContainer", tabs.parentTabs());
      xmlDocument.setParameter("mainTabContainer", tabs.mainTabs());
      // if (!strFIN_Bankstatementline_ID.equals("")) xmlDocument.setParameter("childTabContainer", tabs.childTabs(false));
	  // else xmlDocument.setParameter("childTabContainer", tabs.childTabs(true));
	  xmlDocument.setParameter("childTabContainer", tabs.childTabs(false));
	  String hideBackButton = vars.getGlobalVariable("hideMenu", "#Hide_BackButton", "");
      NavigationBar nav = new NavigationBar(this, vars.getLanguage(), "BankStatementLines_Relation.html", "FinancialAccount", "W", strReplaceWith, tabs.breadcrumb(), hideBackButton.equals("true"), !concurrentSave);
      xmlDocument.setParameter("navigationBar", nav.toString());
      LeftTabsBar lBar = new LeftTabsBar(this, vars.getLanguage(), "BankStatementLines_Relation.html", strReplaceWith);
      xmlDocument.setParameter("leftTabs", lBar.editionTemplate(strCommand.equals("NEW")));
    } catch (Exception ex) {
      throw new ServletException(ex);
    }
		
        xmlDocument.setParameter("APRM_BSProcessed", strAPRM_BSProcessed);
    
    xmlDocument.setParameter("parentOrg", currentPOrg);
    xmlDocument.setParameter("commandType", strCommand);
    xmlDocument.setParameter("buscador",buscador);
    xmlDocument.setParameter("windowId", windowId);
    xmlDocument.setParameter("changed", "");
    xmlDocument.setParameter("language", "defaultLang=\"" + vars.getLanguage() + "\";");
    xmlDocument.setParameter("theme", vars.getTheme());
    final String strMappingName = Utility.getTabURL(tabId, "E", false);
    xmlDocument.setParameter("mappingName", strMappingName);
    xmlDocument.setParameter("confirmOnChanges", Utility.getJSConfirmOnChanges(vars, windowId));
    //xmlDocument.setParameter("buttonReference", Utility.messageBD(this, "Reference", vars.getLanguage()));

    xmlDocument.setParameter("paramSessionDate", strParamSessionDate);

    xmlDocument.setParameter("directory", "var baseDirectory = \"" + strReplaceWith + "/\";\n");
    OBError myMessage = vars.getMessage(tabId);
    vars.removeMessage(tabId);
    if (myMessage!=null) {
      xmlDocument.setParameter("messageType", myMessage.getType());
      xmlDocument.setParameter("messageTitle", myMessage.getTitle());
      xmlDocument.setParameter("messageMessage", myMessage.getMessage());
    }
    xmlDocument.setParameter("displayLogic", getDisplayLogicContext(vars, boolNew));
    
    
     if (dataField==null) {
      xmlDocument.setData("structure1",data);
      
    } else {
      
        FieldProvider[] dataAux = new FieldProvider[1];
        dataAux[0] = dataField;
        
        xmlDocument.setData("structure1",dataAux);
      
    }
    
      
   
    try {
      ComboTableData comboTableData = null;
xmlDocument.setParameter("Datetrx_Format", vars.getSessionValue("#AD_SqlDateFormat"));
xmlDocument.setParameter("buttonDramount", Utility.messageBD(this, "Calc", vars.getLanguage()));
xmlDocument.setParameter("buttonCramount", Utility.messageBD(this, "Calc", vars.getLanguage()));
comboTableData = new ComboTableData(vars, this, "17", "Matchingtype", "BCABCED4983A4ECB814A6D142593ACEA", "", Utility.getReferenceableOrg(vars, (dataField!=null?dataField.getField("adOrgId"):data[0].getField("adOrgId").equals("")?vars.getOrg():data[0].getField("adOrgId"))), Utility.getContext(this, vars, "#User_Client", windowId), 0);
Utility.fillSQLParameters(this, vars, (dataField==null?data[0]:dataField), comboTableData, windowId, (dataField==null?data[0].getField("matchingtype"):dataField.getField("matchingtype")));
xmlDocument.setData("reportMatchingtype","liststructure", comboTableData.select(!strCommand.equals("NEW")));
comboTableData = null;
xmlDocument.setParameter("Created_Format", vars.getSessionValue("#AD_SqlDateTimeFormat"));xmlDocument.setParameter("Created_Maxlength", Integer.toString(vars.getSessionValue("#AD_SqlDateTimeFormat").length()));
xmlDocument.setParameter("Updated_Format", vars.getSessionValue("#AD_SqlDateTimeFormat"));xmlDocument.setParameter("Updated_Maxlength", Integer.toString(vars.getSessionValue("#AD_SqlDateTimeFormat").length()));
    } catch (Exception ex) {
      ex.printStackTrace();
      throw new ServletException(ex);
    }

    xmlDocument.setParameter("scriptOnLoad", getShortcutScript(usedButtonShortCuts));
    
    final String refererURL = vars.getSessionValue(tabId + "|requestURL");
    vars.removeSessionValue(tabId + "|requestURL");
    if(!refererURL.equals("")) {
    	final Boolean failedAutosave = (Boolean) vars.getSessionObject(tabId + "|failedAutosave");
		vars.removeSessionValue(tabId + "|failedAutosave");
    	if(failedAutosave != null && failedAutosave) {
    		final String jsFunction = "continueUserAction('"+refererURL+"');";
    		xmlDocument.setParameter("failedAutosave", jsFunction);
    	}
    }

    if (strCommand.equalsIgnoreCase("NEW")) {
      vars.removeSessionValue(tabId + "|failedAutosave");
      vars.removeSessionValue(strMappingName + "|hash");
    }

    response.setContentType("text/html; charset=UTF-8");
    PrintWriter out = response.getWriter();
    out.println(xmlDocument.print());
    out.close();
  }

  private void printPageButtonFS(HttpServletResponse response, VariablesSecureApp vars, String strProcessId, String path) throws IOException, ServletException {
    log4j.debug("Output: Frames action button");
    response.setContentType("text/html; charset=UTF-8");
    PrintWriter out = response.getWriter();
    XmlDocument xmlDocument = xmlEngine.readXmlTemplate(
        "org/openbravo/erpCommon/ad_actionButton/ActionButtonDefaultFrames").createXmlDocument();
    xmlDocument.setParameter("processId", strProcessId);
    xmlDocument.setParameter("trlFormType", "PROCESS");
    xmlDocument.setParameter("language", "defaultLang = \"" + vars.getLanguage() + "\";\n");
    xmlDocument.setParameter("type", strDireccion + path);
    out.println(xmlDocument.print());
    out.close();
  }





    private String getDisplayLogicContext(VariablesSecureApp vars, boolean isNew) throws IOException, ServletException {
      log4j.debug("Output: Display logic context fields");
      String result = "var strShowAudit=\"" +(isNew?"N":Utility.getContext(this, vars, "ShowAudit", windowId)) + "\";\n";
      return result;
    }


    private String getReadOnlyLogicContext(VariablesSecureApp vars) throws IOException, ServletException {
      log4j.debug("Output: Read Only logic context fields");
      String result = "";
      return result;
    }




 
  private String getShortcutScript( HashMap<String, String> usedButtonShortCuts){
    StringBuffer shortcuts = new StringBuffer();
    shortcuts.append(" function buttonListShorcuts() {\n");
    Iterator<String> ik = usedButtonShortCuts.keySet().iterator();
    Iterator<String> iv = usedButtonShortCuts.values().iterator();
    while(ik.hasNext() && iv.hasNext()){
      shortcuts.append("  keyArray[keyArray.length] = new keyArrayItem(\"").append(ik.next()).append("\", \"").append(iv.next()).append("\", null, \"altKey\", false, \"onkeydown\");\n");
    }
    shortcuts.append(" return true;\n}");
    return shortcuts.toString();
  }
  
  private int saveRecord(VariablesSecureApp vars, OBError myError, char type, String strPFIN_Bankstatement_ID) throws IOException, ServletException {
    BankStatementLinesData data = null;
    int total = 0;
    if (org.openbravo.erpCommon.utility.WindowAccessData.hasReadOnlyAccess(this, vars.getRole(), tabId)) {
        OBError newError = Utility.translateError(this, vars, vars.getLanguage(), Utility.messageBD(this, "NoWriteAccess", vars.getLanguage()));
        myError.setError(newError);
        vars.setMessage(tabId, myError);
    }
    else {
        Connection con = null;
        try {
            con = this.getTransactionConnection();
            data = getEditVariables(con, vars, strPFIN_Bankstatement_ID);
            data.dateTimeFormat = vars.getSessionValue("#AD_SqlDateTimeFormat");            
            String strSequence = "";
            if(type == 'I') {                
        strSequence = SequenceIdData.getUUID();
                if(log4j.isDebugEnabled()) log4j.debug("Sequence: " + strSequence);
                data.finBankstatementlineId = strSequence;  
            }
            if (Utility.isElementInList(Utility.getContext(this, vars, "#User_Client", windowId, accesslevel),data.adClientId)  && Utility.isElementInList(Utility.getContext(this, vars, "#User_Org", windowId, accesslevel),data.adOrgId)){
		     if(type == 'I') {
		       total = data.insert(con, this);
		     } else {
		       //Check the version of the record we are saving is the one in DB
		       if (BankStatementLinesData.getCurrentDBTimestamp(this, data.finBankstatementlineId).equals(
                vars.getStringParameter("updatedTimestamp"))) {
                total = data.update(con, this);
               } else {
                 myError.setMessage(Replace.replace(Replace.replace(Utility.messageBD(this,
                    "SavingModifiedRecord", vars.getLanguage()), "\\n", "<br/>"), "&quot;", "\""));
                 myError.setType("Error");
                 vars.setSessionValue(tabId + "|concurrentSave", "true");
               } 
		     }		            
          
            }
                else {
            OBError newError = Utility.translateError(this, vars, vars.getLanguage(), Utility.messageBD(this, "NoWriteAccess", vars.getLanguage()));
            myError.setError(newError);            
          }
          releaseCommitConnection(con);
        } catch(Exception ex) {
            OBError newError = Utility.translateError(this, vars, vars.getLanguage(), ex.getMessage());
            myError.setError(newError);   
            try {
              releaseRollbackConnection(con);
            } catch (final Exception e) { //do nothing 
            }           
        }
            
        if (myError.isEmpty() && total == 0) {
            OBError newError = Utility.translateError(this, vars, vars.getLanguage(), "@CODE=DBExecuteError");
            myError.setError(newError);
        }
        vars.setMessage(tabId, myError);
            
        if(!myError.isEmpty()){
            if(data != null ) {
                if(type == 'I') {            			
                    data.finBankstatementlineId = "";
                }
                else {                    
                    
                }
                vars.setEditionData(tabId, data);
            }            	
        }
        else {
            vars.setSessionValue(windowId + "|FIN_Bankstatementline_ID", data.finBankstatementlineId);
        }
    }
    return total;
  }

  public String getServletInfo() {
    return "Servlet BankStatementLines. This Servlet was made by Wad constructor";
  } // End of getServletInfo() method
}
